package dev.hope.services;

import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import dev.hope.models.Patient;
import dev.hope.models.ZipCodeDataStream;
import dev.hope.repositories.PatientRepository;
import dev.hope.repositories.ProviderRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.io.Resource;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Random;

@Service
public class DatabaseInitializationService {

    @Value("classpath:Data_Zipcodes.json")
    Resource zipcodeFile;
    @Value("classpath:Data_Patients.json")
    Resource patientFile;

    private ObjectMapper objectMapper = new ObjectMapper();
    private Random rand = new Random();

    @Autowired
    PatientRepository patientRepository;
    @Autowired
    ProviderRepository providerRepository;

    private int[] zipcodesAllowed = {29001,29002,29003,29006,29009,29010,29014,29015,29016,29018,29020,29021,29030,29031,29032,29033,29036,29037,29038,29039,29040,29041,29042,29044,29045,29046,29047,29048,29051,29052,29053,29054,29055,29056,29058,29059,29061,29062,29063,29065,29067,29069,29070,29071,29072,29073,29074,29075,29078,29079,29080,29081,29082,29101,29102,29104,29105,29107,29108,29111,29112,29113,29114,29115,29116,29117,29118,29122,29123,29125,29126,29127,29128,29129,29130,29132,29133,29135,29137,29138,29142,29143,29145,29146,29147,29148,29150,29151,29152,29153,29154,29160,29161,29162,29163,29164,29166,29168,29169,29170,29171,29172,29175,29177,29178,29180,29201,29202,29203,29204,29205,29206,29207,29208,29209,29210,29211,29212,29214,29215,29216,29217,29218,29219,29220,29221,29222,29223,29224,29225,29226,29227,29228,29229,29230,29240,29250,29260,29290,29292,29301,29302,29303,29304,29305,29306,29307,29316,29318,29319,29320,29321,29322,29323,29324,29325,29329,29330,29331,29332,
            29333,29334,29335,29336,29338,29340,29341,29342,29346,29348,29349,29351,29353,29355,29356,29360,29364,29365,29368,29369,29370,29372,29373,29374,29375,29376,29377,29378,29379,29384,29385,29386,29388,29390,29391,29395,29401,29402,29403,29404,29405,29406,29407,29409,29410,29412,29413,29414,29415,29416,29417,29418,29419,29420,29422,29423,29424,29425,29426,29429,29430,29431,29432,29433,29434,29435,29436,29437,29438,29439,29440,29442,29445,29446,29447,29448,29449,29450,29451,29452,29453,29455,29456,29457,29458,29461,29464,29465,29466,29468,29469,29470,29471,29472,29474,29475,29476,29477,29479,29481,29482,29483,29484,29485,29487,29488,29492,29493,29501,29502,29503,29504,29505,29506,29510,29511,29512,29516,29518,29519,29520,29525,29526,29527,29528,29530,29532,29536,29540,29541,29542,29543,29544,29545,29546,29547,29550,29551,29554,29555,29556,29560,29563,29564,29565,29566,29567,29568,29569,29570,29571,29572,29573,29574,29575,29576,29577,29578,29579,29580,29581,29582,29583,29584,
            29585,29587,29588,29589,29590,29591,29592,29593,29594,29596,29597,29598,29601,29602,29603,29604,29605,29606,29607,29608,29609,29610,29611,29612,29613,29614,29615,29616,29617,29620,29621,29622,29623,29624,29625,29626,29627,29628,29630,29631,29632,29633,29634,29635,29636,29638,29639,29640,29641,29642,29643,29644,29645,29646,29647,29648,29649,29650,29651,29652,29653,29654,29655,29656,29657,29658,29659,29661,29662,29664,29665,29666,29667,29669,29670,29671,29672,29673,29675,29676,29677,29678,29679,29680,29681,29682,29683,29684,29685,29686,29687,29688,29689,29690,29691,29692,29693,29695,29696,29697,29698,29702,29703,29704,29706,29708,29709,29710,29712,29714,29715,29716,29717,29718,29720,29721,29722,29724,29726,29727,29728,29729,29730,29731,29732,29733,29734,29741,29742,29743,29744,29745,29801,29802,29803,29804,29805,29808,29809,29810,29812,29813,29816,29817,29819,29821,29822,29824,29826,29827,29828,29829,29831,29832,29834,29835,29836,29838,29839,29840,29841,29842,29843,29844,
            29845,29846,29847,29848,29849,29850,29851,29853,29856,29860,29861,29899,29901,29902,29903,29904,29905,29906,29907,29909,29910,29911,29912,29913,29914,29915,29916,29918,29920,29921,29922,29923,29924,29925,29926,29927,29928,29929,29931,29932,29933,29934,29935,29936,29938,29939,29940,29941,29943,29944,29945,90001,90002,90003,90004,90005,90006,90007,90008,90009,90010,90011,90012,90013,90014,90015,90016,90017,90018,90019,90020,90021,90022,90023,90024,90025,90026,90027,90028,90029,90030,90031,90032,90033,90034,90035,90036,90037,90038,90039,90040,90041,90042,90043,90044,90045,90046,90047,90048,90049,90050,90051,90052,90053,90054,90055,90056,90057,90058,90059,90060,90061,90062,90063,90064,90065,90066,90067,90068,90069,90070,90071,90072,90073,90074,90075,90076,90077,90078,90079,90080,90081,90082,90083,90084,90086,90087,90088,90089,90091,90093,90094,90095,90096,90099,90101,90102,90103,90189,90201,90202,90209,90210,90211,90212,90213,90220,90221,90222,90223,90224,90230,90231,90232,
            90233,90239,90240,90241,90242,90245,90247,90248,90249,90250,90251,90254,90255,90260,90261,90262,90263,90264,90265,90266,90267,90270,90272,90274,90275,90277,90278,90280,90290,90291,90292,90293,90294,90295,90296,90301,90302,90303,90304,90305,90306,90307,90308,90309,90310,90311,90312,90313,90397,90398,90401,90402,90403,90404,90405,90406,90407,90408,90409,90410,90411,90501,90502,90503,90504,90505,90506,90507,90508,90509,90510,90601,90602,90603,90604,90605,90606,90607,90608,90609,90610,90612,90620,90621,90622,90623,90624,90630,90631,90632,90633,90637,90638,90639,90640,90650,90651,90652,90659,90660,90661,90662,90670,90671,90680,90701,90702,90703,90704,90706,90707,90710,90711,90712,90713,90714,90715,90716,90717,90720,90721,90723,90731,90732,90733,90734,90740,90742,90743,90744,90745,90746,90747,90748,90749,90755,90801,90802,90803,90804,90805,90806,90807,90808,90809,90810,90813,90814,90815,90822,90831,90832,90833,90834,90835,90840,90842,90844,90845,90846,90847,90848,90853,90888,
            90895,90899,91001,91003,91006,91007,91009,91010,91011,91012,91016,91017,91020,91021,91023,91024,91025,91030,91031,91040,91041,91042,91043,91046,91066,91077,91101,91102,91103,91104,91105,91106,91107,91108,91109,91110,91114,91115,91116,91117,91118,91121,91123,91124,91125,91126,91129,91131,91182,91184,91185,91188,91189,91191,91199,91201,91202,91203,91204,91205,91206,91207,91208,91209,91210,91214,91221,91222,91224,91225,91226,91301,91302,91303,91304,91305,91306,91307,91308,91309,91310,91311,91313,91316,91319,91320,91321,91322,91324,91325,91326,91327,91328,91329,91330,91331,91333,91334,91335,91337,91340,91341,91342,91343,91344,91345,91346,91350,91351,91352,91353,91354,91355,91356,91357,91358,91359,91360,91361,91362,91363,91364,91365,91367,91371,91372,91376,91377,91380,91381,91382,91383,91384,91385,91386,91387,91388,91390,91392,91393,91394,91395,91396,91399,91401,91402,91403,91404,91405,91406,91407,91408,91409,91410,91411,91412,91413,91416,91423,91426,91436,91470,91482,91495,91496,91497,91499,91501,91502,91503,91504,91505,91506,91507,91508,91510,91521,91522,91523,91526,91601,91602,91603,91604,91605,91606,91607,91608,91609,91610,91611,91612,91614,91615,91616,91617,91618,91701,91702,91706,91708,91709,91710,91711,91714,91715,91716,91722,91723,91724,91729,91730,91731,91732,91733,91734,91735,91737,91739,91740,91741,91743,91744,91745,91746,91747,91748,91749,91750,91752,91754,91755,91756,91758,91759,91761,91762,91763,91764,91765,91766,91767,91768,91769,91770,91771,91772,91773,91775,91776,91778,91780,91784,91785,91786,91788,91789,91790,91791,91792,91793,91795,91797,91798,91799,91801,91802,91803,91804,91841,91896,91899,91901,91902,91903,91905,91906,91908,91909,91910,91911,91912,91913,91914,91915,91916,91917,91921,91931,91932,91933,91934,91935,91941,91942,91943,91944,91945,91946,91947,91948,91950,91951,91962,91963,91976,91977,91978,91979,91980,91987,91990,92003,92004,92007,92008,92009,92010,92011,92013,92014,92018,92019,92020,92021,92022,92023,92024,92025,92026,92027,92028,92029,92030,92033,92036,92037,92038,92039,92040,92046,92049,92051,92052,92054,92055,92056,92057,92059,92060,92061,92064,92065,92066,92067,92068,92069,92070,92071,92072,92074,92075,92078,92079,92081,92082,92083,92084,92085,92086,92088,92090,92091,92092,92093,92096,92101,92102,92103,92104,92105,92106,92107,92108,92109,92110,92111,92112,92113,92114,92115,92116,92117,92118,92119,92120,92121,92122,92123,92124,92126,92127,92128,92129,92130,92131,92132,92133,92134,92135,92136,92137,92138,92139,92140,92142,92143,92145,92147,92149,92150,92152,92153,92154,92155,92158,92159,92160,92161,92162,92163,92164,92165,92166,92167,92168,92169,92170,92171,92172,92173,92174,92175,92176,92177,92178,92179,92182,92184,92186,92187,92190,92191,92192,92193,92194,92195,92196,92197,92198,92199,92201,92202,92203,92210,92211,92220,92222,92223,92225,92226,92227,92230,92231,92232,92233,92234,92235,92236,92239,92240,92241,92242,92243,92244,92247,92248,92249,92250,92251,92252,92253,92254,92255,92256,92257,92258,92259,92260,92261,92262,92263,92264,92266,92267,92268,92270,92273,92274,92275,92276,92277,92278,92280,92281,92282,92283,92284,92285,92286,92292,92301,92304,92305,92307,92308,92309,92310,92311,92312,92313,92314,92315,92316,92317,92318,92320,92321,92322,92323,92324,92325,92326,92327,92328,92329,92331,92332,92333,92334,92335,92336,92337,92338,92339,92340,92341,92342,92344,92345,92346,92347,92350,92352,92354,92356,92357,92358,92359,92363,92364,92365,92366,92368,92369,92371,92372,92373,92374,92375,92376,92377,92378,92382,92384,92385,92386,92389,92391,92392,92393,92394,92395,92397,92398,92399,92401,92402,92403,92404,92405,92406,92407,92408,92410,92411,92412,92413,92414,92415,92418,92423,92424,92427,92501,92502,92503,92504,92505,92506,92507,92508,92509,92513,92514,92515,92516,92517,92518,92519,92521,92522,92530,92531,92532,92536,92539,92543,92544,92545,92546,92548,92549,92551,92552,92553,92554,92555,92556,92557,92561,92562,92563,92564,92567,92570,92571,92572,92581,92582,92583,92584,92585,92586,92587,92589,92590,92591,92592,92593,92595,92596,92599,92602,92603,92604,92605,92606,92607,92609,92610,92612,92614,92615,92616,92617,92618,92619,92620,92623,92624,92625,92626,92627,92628,92629,92630,92637,92646,92647,92648,92649,92650,92651,92652,92653,92654,92655,92656,92657,92658,92659,92660,92661,92662,92663,92672,92673,92674,92675,92676,92677,92678,92679,92683,92684,92685,92688,92690,92691,92692,92693,92694,92697,92698,92701,92702,92703,92704,92705,92706,92707,92708,92709,92710,92711,92712,92725,92728,92735,92780,92781,92782,92799,92801,92802,92803,92804,92805,92806,92807,92808,92809,92811,92812,92814,92815,92816,92817,92821,92822,92823,92825,92831,92832,92833,92834,92835,92836,92837,92838,92840,92841,92842,92843,92844,92845,92846,92850,92856,92857,92859,92860,92861,92862,92863,92864,92865,92866,92867,92868,92869,92870,92871,92877,92878,92879,92880,92881,92882,92883,92885,92886,92887,92899,93001,93002,93003,93004,93005,93006,93007,93009,93010,93011,93012,93013,93014,93015,93016,93020,93021,93022,93023,93024,93030,93031,93032,93033,93034,93035,93036,93040,93041,93042,93043,93044,93060,93061,93062,93063,93064,93065,93066,93067,93093,93094,93099,93101,93102,93103,93105,93106,93107,93108,93109,93110,93111,93116,93117,93118,93120,93121,93130,93140,93150,93160,93190,93199,93201,93202,93203,93204,93205,93206,93207,93208,93210,93212,93215,93216,93218,93219,93220,93221,93222,93223,93224,93225,93226,93227,93230,93232,93234,93235,93237,93238,93239,93240,93241,93242,93243,93244,93245,93246,93247,93249,93250,93251,93252,93254,93255,93256,93257,93258,93260,93261,93262,93263,93265,93266,93267,93268,93270,93271,93272,93274,93275,93276,93277,93278,93279,93280,93282,93283,93285,93286,93287,93290,93291,93292,93301,93302,93303,93304,93305,93306,93307,93308,93309,93311,93312,93313,93314,93380,93381,93382,93383,93384,93385,93386,93387,93388,93389,93390,93401,93402,93403,93405,93406,93407,93408,93409,93410,93412,93420,93421,93422,93423,93424,93426,93427,93428,93429,93430,93432,93433,93434,93435,93436,93437,93438,93440,93441,93442,93443,93444,93445,93446,93447,93448,93449,93450,93451,93452,93453,93454,93455,93456,93457,93458,93460,93461,93463,93464,93465,93475,93483,93501,93502,93504,93505,93510,93512,93513,93514,93515,93516,93517,93518,93519,93522,93523,93524,93526,93527,93528,93529,93530,93531,93532,93534,93535,93536,93539,93541,93542,93543,93544,93545,93546,93549,93550,93551,93552,93553,93554,93555,93556,93558,93560,93561,93562,93563,93581,93584,93586,93590,93591,93592,93596,93599,93601,93602,93603,93604,93605,93606,93607,93608,93609,93610,93611,93612,93613,93614,93615,93616,93618,93619,93620,93621,93622,93623,93624,93625,93626,93627,93628,93630,93631,93633,93634,93635,93636,93637,93638,93639,93640,93641,93642,93643,93644,93645,93646,93647,93648,93649,93650,93651,93652,93653,93654,93656,93657,93660,93661,93662,93664,93665,93666,93667,93668,93669,93670,93673,93675,93701,93702,93703,93704,93705,93706,93707,93708,93709,93710,93711,93712,93714,93715,93716,93717,93718,93720,93721,93722,93723,93724,93725,93726,93727,93728,93729,93730,93740,93741,93744,93745,93747,93750,93755,93760,93761,93764,93765,93771,93772,93773,93774,93775,93776,93777,93778,93779,93780,93784,93786,93790,93791,93792,93793,93794,93844,93888,93901,93902,93905,93906,93907,93908,93912,93915,93920,93921,93922,93923,93924,93925,93926,93927,93928,93930,93932,93933,93940,93942,93943,93944,93950,93953,93954,93955,93960,93962,94002,94005,94010,94011,94013,94014,94015,94016,94017,94018,94019,94020,94021,94022,94023,94024,94025,94026,94027,94028,94030,94035,94037,94038,94039,94040,94041,94042,94043,94044,94060,94061,94062,94063,94064,94065,94066,94070,94074,94080,94083,94085,94086,94087,94088,94089,94096,94098,94101,94102,94103,94104,94105,94106,94107,94108,94109,94110,94111,94112,94114,94115,94116,94117,94118,94119,94120,94121,94122,94123,94124,94125,94126,94127,94128,94129,94130,94131,94132,94133,94134,94135,94136,94137,94138,94139,94140,94141,94142,94143,94144,94145,94146,94147,94150,94151,94152,94153,94154,94155,94156,94157,94158,94159,94160,94161,94162,94163,94164,94165,94166,94167,94168,94169,94170,94171,94172,94175,94177,94188,94199,94203,94204,94205,94206,94207,94208,94209,94211,94229,94230,94232,94234,94235,94236,94237,94239,94240,94244,94245,94246,94247,94248,94249,94250,94252,94254,94256,94257,94258,94259,94261,94262,94263,94267,94268,94269,94271,94273,94274,94277,94278,94279,94280,94282,94283,94284,94285,94286,94287,94288,94289,94290,94291,94293,94294,94295,94296,94297,94298,94299,94301,94302,94303,94304,94305,94306,94309,94401,94402,94403,94404,94497,94501,94502,94503,94506,94507,94508,94509,94510,94511,94512,94513,94514,94515,94516,94517,94518,94519,94520,94521,94522,94523,94524,94525,94526,94527,94528,94529,94530,94531,94533,94534,94535,94536,94537,94538,94539,94540,94541,94542,94543,94544,94545,94546,94547,94548,94549,94550,94551,94552,94553,94555,94556,94557,94558,94559,94560,94561,94562,94563,94564,94565,94566,94567,94568,94569,94570,94571,94572,94573,94574,94575,94576,94577,94578,94579,94580,94581,94582,94583,94585,94586,94587,94588,94589,94590,94591,94592,94595,94596,94597,94598,94599,94601,94602,94603,94604,94605,94606,94607,94608,94609,94610,94611,94612,94613,94614,94615,94617,94618,94619,94620,94621,94622,94623,94624,94625,94649,94659,94660,94661,94662,94666,94701,94702,94703,94704,94705,94706,94707,94708,94709,94710,94712,94720,94801,94802,94803,94804,94805,94806,94807,94808,94820,94850,94901,94903,94904,94912,94913,94914,94915,94920,94922,94923,94924,94925,94926,94927,94928,94929,94930,94931,94933,94937,94938,94939,94940,94941,94942,94945,94946,94947,94948,94949,94950,94951,94952,94953,94954,94955,94956,94957,94960,94963,94964,94965,94966,94970,94971,94972,94973,94974,94975,94976,94977,94978,94979,94998,94999,95001,95002,95003,95004,95005,95006,95007,95008,95009,95010,95011,95012,95013,95014,95015,95017,95018,95019,95020,95021,95023,95024,95026,95030,95031,95032,95033,95035,95036,95037,95038,95039,95041,95042,95043,95044,95045,95046,95050,95051,95052,95053,95054,95055,95056,95060,95061,95062,95063,95064,95065,95066,95067,95070,95071,95073,95075,95076,95077,95101,95103,95106,95108,95109,95110,95111,95112,95113,95115,95116,95117,95118,95119,95120,95121,95122,95123,95124,95125,95126,95127,95128,95129,95130,95131,95132,95133,95134,95135,95136,95138,95139,95140,95141,95148,95150,95151,95152,95153,95154,95155,95156,95157,95158,95159,95160,95161,95164,95170,95172,95173,95190,95191,95192,95193,95194,95196,95201,95202,95203,95204,95205,95206,95207,95208,95209,95210,95211,95212,95213,95215,95219,95220,95221,95222,95223,95224,95225,95226,95227,95228,95229,95230,95231,95232,95233,95234,95236,95237,95240,95241,95242,95245,95246,95247,95248,95249,95250,95251,95252,95253,95254,95255,95257,95258,95267,95269,95296,95297,95301,95303,95304,95305,95306,95307,95309,95310,95311,95312,95313,95314,95315,95316,95317,95318,95319,95320,95321,95322,95323,95324,95325,95326,95327,95328,95329,95330,95333,95334,95335,95336,95337,95338,95340,95341,95343,95344,95345,95346,95347,95348,95350,95351,95352,95353,95354,95355,95356,95357,95358,95360,95361,95363,95364,95365,95366,95367,95368,95369,95370,95372,95373,95374,95375,95376,95377,95378,95379,95380,95381,95382,95383,95385,95386,95387,95388,95389,95391,95397,95401,95402,95403,95404,95405,95406,95407,95408,95409,95410,95412,95415,95416,95417,95418,95419,95420,95421,95422,95423,95424,95425,95426,95427,95428,95429,95430,95431,95432,95433,95435,95436,95437,95439,95441,95442,95443,95444,95445,95446,95448,95449,95450,95451,95452,95453,95454,95456,95457,95458,95459,95460,95461,95462,95463,95464,95465,95466,95467,95468,95469,95470,95471,95472,95473,95476,95480,95481,95482,95485,95486,95487,95488,95490,95492,95493,95494,95497,95501,95502,95503,95511,95514,95518,95519,95521,95524,95525,95526,95527,95528,95531,95532,95534,95536,95537,95538,95540,95542,95543,95545,95546,95547,95548,95549,95550,95551,95552,95553,95554,95555,95556,95558,95559,95560,95562,95563,95564,95565,95567,95568,95569,95570,95571,95573,95585,95587,95589,95595,95601,95602,95603,95604,95605,95606,95607,95608,95609,95610,95611,95612,95613,95614,95615,95616,95617,95618,95619,95620,95621,95623,95624,95625,95626,95627,95628,95629,95630,95631,95632,95633,95634,95635,95636,95637,95638,95639,95640,95641,95642,95644,95645,95646,95648,95650,95651,95652,95653,95654,95655,95656,95658,95659,95660,95661,95662,95663,95664,95665,95666,95667,95668,95669,95670,95671,95672,95673,95674,95675,95676,95677,95678,95679,95680,95681,95682,95683,95684,95685,95686,95687,95688,95689,95690,95691,95692,95693,95694,95695,95696,95697,95698,95699,95701,95703,95709,95712,95713,95714,95715,95717,95720,95721,95722,95724,95726,95728,95735,95736,95741,95742,95746,95747,95757,95758,95759,95762,95763,95765,95776,95798,95799,95812,95813,95814,95815,95816,95817,95818,95819,95820,95821,95822,95823,95824,95825,95826,95827,95828,95829,95830,95831,95832,95833,95834,95835,95836,95837,95838,95840,95841,95842,95843,95851,95852,95853,95860,95864,95865,95866,95867,95887,95894,95899,95901,95903,95910,95912,95913,95914,95915,95916,95917,95918,95919,95920,95922,95923,95924,95925,95926,95927,95928,95929,95930,95932,95934,95935,95936,95937,95938,95939,95940,95941,95942,95943,95944,95945,95946,95947,95948,95949,95950,95951,95953,95954,95955,95956,95957,95958,95959,95960,95961,95962,95963,95965,95966,95967,95968,95969,95970,95971,95972,95973,95974,95975,95976,95977,95978,95979,95980,95981,95982,95983,95984,95986,95987,95988,95991,95992,95993,96001,96002,96003,96006,96007,96008,96009,96010,96011,96013,96014,96015,96016,96017,96019,96020,96021,96022,96023,96024,96025,96027,96028,96029,96031,96032,96033,96034,96035,96037,96038,96039,96040,96041,96044,96046,96047,96048,96049,96050,96051,96052,96054,96055,96056,96057,96058,96059,96061,96062,96063,96064,96065,96067,96068,96069,96070,96071,96073,96074,96075,96076,96078,96079,96080,96084,96085,96086,96087,96088,96089,96090,96091,96092,96093,96094,96095,96096,96097,96099,96101,96103,96104,96105,96106,96107,96108,96109,96110,96111,96112,96113,96114,96115,96116,96117,96118,96119,96120,96121,96122,96123,96124,96125,96126,96127,96128,96129,96130,96132,96133,96134,96135,96136,96137,96140,96141,96142,96143,96145,96146,96148,96150,96151,96152,96154,96155,96156,96157,96158,96160,96161,96162,98001,98002,98003,98004,98005,98006,98007,98008,98009,98010,98011,98012,98013,98014,98015,98019,98020,98021,98022,98023,98024,98025,98026,98027,98028,98029,98030,98031,98032,98033,98034,98035,98036,98037,98038,98039,98040,98041,98042,98043,98045,98046,98047,98050,98051,98052,98053,98054,98055,98056,98057,98058,98059,98061,98062,98063,98064,98065,98068,98070,98071,98072,98073,98074,98075,98077,98082,98083,98089,98092,98093,98101,98102,98103,98104,98105,98106,98107,98108,98109,98110,98111,98112,98113,98114,98115,98116,98117,98118,98119,98121,98122,98124,98125,98126,98127,98129,98131,98132,98133,98134,98136,98138,98139,98141,98144,98145,98146,98148,98151,98154,98155,98158,98160,98161,98164,98165,98166,98168,98170,98171,98174,98175,98177,98178,98181,98184,98185,98188,98190,98191,98194,98195,98198,98199,98201,98203,98204,98205,98206,98207,98208,98213,98220,98221,98222,98223,98224,98225,98226,98227,98228,98229,98230,98231,98232,98233,98235,98236,98237,98238,98239,98240,98241,98243,98244,98245,98247,98248,98249,98250,98251,98252,98253,98255,98256,98257,98258,98259,98260,98261,98262,98263,98264,98266,98267,98270,98271,98272,98273,98274,98275,98276,98277,98278,98279,98280,98281,98282,98283,98284,98286,98287,98288,98290,98291,98292,98293,98294,98295,98296,98297,98303,98304,98305,98310,98311,98312,98314,98315,98320,98321,98322,98323,98324,98325,98326,98327,98328,98329,98330,98331,98332,98333,98335,98336,98337,98338,98339,98340,98342,98343,98344,98345,98346,98348,98349,98350,98351,98352,98353,98354,98355,98356,98357,98358,98359,98360,98361,98362,98363,98364,98365,98366,98367,98368,98370,98371,98372,98373,98374,98375,98376,98377,98378,98380,98381,98382,98383,98384,98385,98386,98387,98388,98390,98391,98392,98393,98394,98395,98396,98397,98398,98401,98402,98403,98404,98405,98406,98407,98408,98409,98411,98412,98413,98415,98416,98417,98418,98419,98421,98422,98424,98430,98431,98433,98438,98439,98442,98443,98444,98445,98446,98447,98448,98450,98455,98460,98464,98465,98466,98467,98471,98477,98481,98490,98492,98493,98496,98497,98498,98499,98501,98502,98503,98504,98505,98506,98507,98508,98509,98511,98512,98513,98516,98520,98522,98524,98526,98527,98528,98530,98531,98532,98533,98535,98536,98537,98538,98539,98540,98541,98542,98544,98546,98547,98548,98550,98552,98554,98555,98556,98557,98558,98559,98560,98561,98562,98563,98564,98565,98566,98568,98569,98570,98571,98572,98575,98576,98577,98579,98580,98581,98582,98583,98584,98585,98586,98587,98588,98589,98590,98591,98592,98593,98595,98596,98597,98599,98601,98602,98603,98604,98605,98606,98607,98609,98610,98611,98612,98613,98614,98616,98617,98619,98620,98621,98622,98623,98624,98625,98626,98628,98629,98631,98632,98635,98637,98638,98639,98640,98641,98642,98643,98644,98645,98647,98648,98649,98650,98651,98660,98661,98662,98663,98664,98665,98666,98667,98668,98670,98671,98672,98673,98674,98675,98682,98683,98684,98685,98686,98687,98801,98802,98807,98811,98812,98813,98814,98815,98816,98817,98819,98821,98822,98823,98824,98826,98827,98828,98829,98830,98831,98832,98833,98834,98836,98837,98840,98841,98843,98844,98845,98846,98847,98848,98849,98850,98851,98852,98853,98855,98856,98857,98858,98859,98860,98862,98901,98902,98903,98904,98907,98908,98909,98920,98921,98922,98923,98925,98926,98929,98930,98932,98933,98934,98935,98936,98937,98938,98939,98940,98941,98942,98943,98944,98946,98947,98948,98950,98951,98952,98953,99001,99003,99004,99005,99006,99008,99009,99011,99012,99013,99014,99016,99017,99018,99019,99020,99021,99022,99023,99025,99026,99027,99029,99030,99031,99032,99033,99034,99036,99037,99039,99040,99101,99102,99103,99104,99105,99107,99109,99110,99111,99113,99114,99115,99116,99117,99118,99119,99121,99122,99123,99124,99125,99126,99128,99129,99130,99131,99133,99134,99135,99136,99137,99138,99139,99140,99141,99143,99144,99146,99147,99148,99149,99150,99151,99152,99153,99154,99155,99156,99157,99158,99159,99160,99161,99163,99164,99165,99166,99167,99169,99170,99171,99173,99174,99176,99179,99180,99181,99185,99201,99202,99203,99204,99205,99206,99207,99208,99209,99210,99211,99212,99213,99214,99215,99216,99217,99218,99219,99220,99223,99224,99228,99251,99252,99256,99258,99260,99299,99301,99302,99320,99321,99322,99323,99324,99326,99328,99329,99330,99333,99335,99336,99337,99338,99341,99343,99344,99345,99346,99347,99348,99349,99350,99352,99353,99354,99356,99357,99359,99360,99361,99362,99363,99371,99401,99402,99403};

    public DatabaseInitializationService() {
        SimpleDateFormat df = new SimpleDateFormat("dd/MM/yyyy");
        objectMapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
        objectMapper.setDateFormat(df);
    }

    public void addProviders(){

    }

    public void addPatients(){
        try {
            Patient[] patients = objectMapper.readValue(patientFile.getFile(), Patient[].class);
            int i = 0;
            for(Patient patient: patients){
                patient.setZipcode(String.valueOf(zipcodesAllowed[rand.nextInt(zipcodesAllowed.length)]));
                if(rand.nextInt(5)==1)
                    patient.setPreExistingCondition(true);
                patientRepository.save(patient);
                if(i < 50)
                    System.out.println(patient);
                i++;
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void addLocations(){

    }
}
